#ifndef __DATAFLASH_H__
#define __DATAFLASH_H__
#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"
/*********************** Flashռ仮 *****************************
*   0xFFFD  ---
*            |                   Code Flash(BOOT3K)
*   0xF400  ---
*   0xF3FF  ---
*            |                   Data Flash1K
*   0xF000  ---
*   0xEFFF  ---
*            |                   Code Flashû60K
*   0x0000  ---
******************************************************************/
/* Ӻ */
/* Code FlashData Flash */
extern UINT8 FlashErasePage( UINT16 Addr ) ;
extern UINT8 FlashProgByte( UINT16 Addr,UINT8 Data );
extern UINT8 FlashProgPage( UINT16 Addr, PUINT8X Buf,UINT8 len );
extern UINT8 FlashReadBuf(UINT16 Addr,PUINT8 buf,UINT16 len);
/* OTPReadOnly */
extern UINT8  FlashProgOTPbyte( UINT8 Addr, UINT8 Data );
extern UINT32 FlashReadOTPword( UINT8 Addr );
#endif
