/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/09
* Description        : CH549 FlashRomʾʾ
                       1DataFlashд
                                 2CodeFlashд
                                 3Ϣȡ
                                 4豸ΨһIDȡ
                                 5OTPд
*******************************************************************************/
#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"
#include ".\FlashRom\FlashRom.H"
#pragma  NOAREGS
UINT8X FlashBuf[64] _at_ 0x0000;                                               //ӦFlashҳдһҳ,Ҫ64ֽڶ
UINT8X temp[64];
void main()
{
    UINT8 s,i,len;
    CfgFsys( );                                                                //CH549ʱѡ
    mDelaymS(20);
    mInitSTDIO( );                                                             //0ʼ
    printf("FlashRom demo start ...\n");
    for(i=0; i!=64; i++)
    {
        FlashBuf[i]=i;
    }
    /* 1DataFlash ʾ */
    memset(temp,0,64);
    printf("DataFlash Erase...\n");
    s = FlashErasePage( 0xF000 ) ;                                             //DataFlashĵһҳ
    if(s!=0x00)
    {
        printf("%02x \n",(UINT16)s);
    }
    printf("DataFlash Write...\n");
    s = FlashProgPage( 0xF000, FlashBuf,64 );
    if(s!=0x00)
    {
        printf("%02x \n",(UINT16)s);
    }
    printf("DataFlash Read...\n");
    len = FlashReadBuf(0xF000,temp,64);
    printf("real len:%d\n",(UINT16)len);
    for(i=0; i!=len; i++)
    {
        printf("%02x ",(UINT16)temp[i]);
        if(temp[i]!=FlashBuf[i])
        {
            printf("Err Offset:%02x\n",i);
            while(1)
            {
                ;
            }
        }
    }
    printf("\n\n");
    /* 2Code Flash ʾ(BOOTû޶дȨ) */
    memset(temp,0,64);
    printf("CodeFlash Erase...\n");
    s = FlashErasePage( 0xEFC0 ) ;                                             //CodeFlash 0xEFC0ҳ
    if(s!=0x00)
    {
        printf("%02x \n",(UINT16)s);
    }
    printf("CodeFlash Write...\n");
    s = FlashProgPage( 0xEFC0, &FlashBuf[0],64 );
    if(s!=0x00)
    {
        printf("%02x \n",(UINT16)s);
    }
    printf("CodeFlash Read...\n");
    len = FlashReadBuf(0xEFC0,temp,64);
    printf("real len:%d\n",(UINT16)len);
    for(i=0; i!=len; i++)
    {
        printf("%02x ",(UINT16)temp[i]);
        if(temp[i]!=FlashBuf[i])
        {
            printf("Err Offset:%02x\n",i);
            while(1)
            {
                ;
            }
        }
    }
    printf("\n\n");
    /* 316ֽλȡ */
    printf("Config Information Read...\n");
    len = FlashReadBuf(0xFFFE,temp,2);
    printf("real len:%d\n",(UINT16)len);
    printf("cfg:%02x %02x\n",(UINT16)temp[1],(UINT16)temp[0]);
    /* 4ȡ豸ΨһIDַֻ 10H~15H 16h~17HУ */
    printf("Unique ID...\n");
    printf("0x%lx ",FlashReadOTPword( 0x14 ));                                 //17H,16H,15H,14H
    printf("0x%lx\n",FlashReadOTPword( 0x10 ));                                //13H,12H,11H,10H
#if 0
    /* 5OTP (ֻ01,Ҳɲ) */
    printf("OTP Read:");
    printf("0x%lx \n",FlashReadOTPword( 0x20 ));                               //ȡ0x20ʼֽ
    printf("OTP Write ...\n");
    s = FlashProgOTPbyte( 0x20, 0x4f );                                        //0x20ַʼд
    if(s!=0x00)
    {
        printf("s = %02x \n",(UINT16)s);
    }
    s = FlashProgOTPbyte( 0x21, 0x58 );
    if(s!=0x00)
    {
        printf("s = %02x \n",(UINT16)s);
    }
    s = FlashProgOTPbyte( 0x22, 0x54 );
    if(s!=0x00)
    {
        printf("s = %02x \n",(UINT16)s);
    }
    s = FlashProgOTPbyte( 0x23, 0x63 );
    if(s!=0x00)
    {
        printf("s = %02x \n",(UINT16)s);
    }
    printf("OTP Read:");
    printf("0x%lx \n",FlashReadOTPword( 0x20 ));                               //ٴζȡ0x20ʼֽ
#endif
    while(1)
    {
    }
}
