/********************************** (C) COPYRIGHT *******************************
* File Name          : SPI.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/23
* Description        : CH549 SPIģʽӿں
עƬѡЧʱӻԶSPI0_S_PREԤֵλÿƬѡ
ЧǰSPI0_S_PREĴдԤֵ˶׸ֽڣʱע
ȡSPI0_S_PREֵһS0_IF_BYTEжϡ
ƬѡЧЧӻȽз͵ĻðֽڷŵSPI0_S_PREĴУ
ѾƬѡЧĻʹSPI0_DATAͿ
*******************************************************************************/
#include ".\SPI\SPI.H"
#pragma  NOAREGS
/*******************************************************************************
* Function Name  : SPIMasterModeSet( UINT8 mode )
* Description    : SPIģʽʼ
* Input          : UINT8 mode
* Output         : None
* Return         : None
*******************************************************************************/
void SPIMasterModeSet(UINT8 mode)
{
    SCS = 1;
    P1_MOD_OC &= ~(bSCS|bMOSI|bSCK);
    P1_DIR_PU |= (bSCS|bMOSI|bSCK);                                            //SCS,MOSI,SCK
    P1_MOD_OC |= bMISO;                                                        //MISO 
    P1_DIR_PU |= bMISO;
    SPI0_SETUP = 0;                                                           //Masterģʽ,λǰ
    if(mode == 0)
    {
        SPI0_CTRL = (bS0_MOSI_OE|bS0_SCK_OE);                                   //ģʽ0
    }
    else if(mode == 3)
    {
        SPI0_CTRL = (bS0_MOSI_OE|bS0_SCK_OE|bS0_MST_CLK);                       //ģʽ3
    }
}
/*******************************************************************************
* Function Name  : CH549SPIMasterWrite(UINT8 dat)
* Description    : CH549ӲSPIд,ģʽ
* Input          : UINT8 dat   
* Output         : None
* Return         : None
*******************************************************************************/
void CH549SPIMasterWrite(UINT8 dat)
{
    SPI0_DATA = dat;
    while(S0_FREE == 0)
    {
        ;    //ȴ
    }
}
/*******************************************************************************
* Function Name  : CH549SPIMasterRead( )
* Description    : CH549ӲSPI0ݣģʽ
* Input          : None
* Output         : None
* Return         : UINT8 ret
*******************************************************************************/
UINT8 CH549SPIMasterRead()
{
    SPI0_DATA = 0xff;
    while(S0_FREE == 0)
    {
        ;
    }
    return SPI0_DATA;
}
/*******************************************************************************
* Function Name  : SPISlvModeSet( )
* Description    : SPIӻģʽʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SPISlvModeSet( )
{
    P1_MOD_OC &= ~(bSCS|bMOSI|bSCK);                                          //SCS,MOSI,SCK 
    P1_DIR_PU &= ~(bSCS|bMOSI|bSCK);
    P1_MOD_OC &= ~bMISO;                                                      //MISO
    P1_DIR_PU |= bMISO;
    SPI0_S_PRE = 0x66;                                                        //Ԥֵ,ֵ
    SPI0_SETUP = bS0_MODE_SLV;                                                //Slvģʽ,λǰ
    SPI0_CTRL = bS0_MISO_OE;                                                  //MISO ʹ
#ifdef SPI_INTERRUPT
    SPI0_SETUP |= bS0_IE_FIRST | bS0_IE_BYTE;
    IE_SPI0 = 1;
    EA = 1;
#endif
}
/*******************************************************************************
* Function Name  : CH549SPISlvWrite(UINT8 dat)
* Description    : CH549ӲSPIдݣӻģʽ
* Input          : UINT8 dat   
* Output         : None
* Return         : None
*******************************************************************************/
void CH549SPISlvWrite(UINT8 dat)
{
    SPI0_DATA = dat;
    while(S0_FREE==0)
    {
        ;
    }
}
/*******************************************************************************
* Function Name  : CH549SPISlvRead( )
* Description    : CH549ӲSPI0ݣӻģʽ
* Input          : None
* Output         : None
* Return         : UINT8 ret
*******************************************************************************/
UINT8 CH549SPISlvRead()
{
    while(S0_FREE == 0)
    {
        ;
    }
    return SPI0_DATA;
}
#ifdef SPI_INTERRUPT
/*******************************************************************************
* Function Name  : SPIInterrupt(void)
* Description    : SPI жϷ
*******************************************************************************/
void SPIInterrupt( void ) interrupt INT_NO_SPI0 using 1        //SPIжϷ,ʹüĴ1
{
    UINT8 dat;
    dat = CH549SPISlvRead();
    CH549SPISlvWrite(dat^0xFF);
#if DE_PRINTF
    printf("Read#%02x\n",(UINT16)dat);
#endif
}
#endif
