/********************************** (C) COPYRIGHT ******************************
* File Name          : CH549_IAP.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/24
* Description        : IAP ʾӳ
*                      1֧USBأUSBΪȫԶ豸
*                      2֧CodeFlash
                       עDEBUG.C
*******************************************************************************/
#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"
#include ".\IAP\IAP\CH549_IAP.H"
/******************************************************************************
*  עCH549_IAP.CҪCH549_USER.Cʹ
*  ע⣺Ӵ0xE000ʼIAP,ҲǴ56KʼIAP,56K-60KλÿڴIAP
*  ǰָӵַ Option->Target Code Memeryѡ Epromʼַ:0xE004
*
*  ӵַƫֽڵ˵IAPCodeFlash棬ɵBINļͷĸֽת
*  IAPmainָUSERIAP֮ǰǷûļģĸֽڵת
*  IAPmainָᵽĳ̶ַIAPļʱƫ4ֽھΪת
*  ָڵط
*******************************************************************************/
#define THIS_ENDP0_SIZE         DEFAULT_ENDP0_SIZE               //Ĭ϶˵0ĴС
// 豸
UINT8C MyDevDescr[] = { 0x12, 0x01, 0x10, 0x01,
                        0xFF, 0x80, 0x55, THIS_ENDP0_SIZE,
                        0x48, 0x43, 0xe0, 0x55,
                        0x00, 0x01, 0x00, 0x00,0x00, 0x01
                      };
// 
UINT8C MyCfgDescr[] = { 0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
                        0x09, 0x04, 0x00, 0x00, 0x02, 0xFF, 0x80, 0x55, 0x00,
                        0x07, 0x05, 0x82, 0x02, 0x40, 0x00, 0x00,
                        0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00
                      };
UINT8X UsbConfig = 0;                                            // USBñ־
UINT8X Ep0Buffer[ THIS_ENDP0_SIZE+2 ] _at_ 0x0000 ;              // OUT&IN, must even address
UINT8X Ep2Buffer[ 2*MAX_PACKET_SIZE+4 ] _at_ THIS_ENDP0_SIZE+2 ; // OUT+IN, must even address
#define   UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)
UINT8X SetupReqCode,SetupLen;
PUINT8 pDescr;

iap_cmd1 xdata iap_cmd _at_ 0x00C6;                              //IAP
UINT8X uart_bit;                                                 //طʽȫֱ־λ1ʾΪڣ2ʾΪUSB
UINT16X chip_id,eeprom_len;
PUINT8C pCode;
#pragma NOAREGS
sbit DisableIAP = P1^0;                                         //λ,û򴥷
sbit D2 = P2^2;
UINT16X cur_block,last_block;                                   //64ֽһ飬ʾǰǰһεĿţƿĲ

/*******************************************************************************
* Function Name  : ErasePage( UINT16 Addr )
* Description    : ҳÿ64ֽΪһҳҳݱΪ0x00
* Input          : Addr:ַҳ
* Output         : None
* Return         : ز״̬0x00:ɹ  0x01:ַЧ  0x02:δ֪ʱ
*******************************************************************************/
UINT8 FlashErasePage( UINT16 Addr )
{
    bit e_all;
    UINT8 status;                                    /* ز״̬ */
    UINT8 FlashType;                                 /* Flash ͱ־ */
    e_all = EA;
    EA = 0;                                          /* رȫж,ֹFlash */
    Addr &= 0xFFC0;                                  /* 64ֽڶ */
    if((Addr>0xEFFF) && (Addr<0xF400))               /* DataFlash */
    {
        FlashType = bDATA_WE;
    }
    else                                             /* CodeFlash */
    {
        FlashType = bCODE_WE;
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG |= FlashType;
    ROM_ADDR = Addr;                                 /* дĿַ */
    ROM_BUF_MOD = bROM_BUF_BYTE;                     /* ѡģʽֽڱģʽ */
    ROM_DAT_BUF = 0;                                 /* дݻĴΪ0 */
    if ( ROM_STATUS & bROM_ADDR_OK )                 /* ַЧ */
    {
        ROM_CTRL = ROM_CMD_ERASE;                    /*  */
        if(ROM_STATUS & bROM_CMD_ERR)
        {
            status = 0x02;    /* δ֪ʱ */
        }
        else
        {
            status = 0x00;    /* ɹ */
        }
    }
    else
    {
        status = 0x01;    /* ַЧ */
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG &= ~FlashType;                        /* д */
    EA = e_all;                                      /* ָȫж״̬ */
    return status;
}
/*******************************************************************************
* Function Name  : FlashProgByte(UINT16 Addr,UINT8 Data)
* Description    : Flash ֽڱ
* Input          : Addrдַ
*                  Dataֽڱ̵
* Output         : None
* Return         : ״̬ 0x00:ɹ  0x01:ַЧ  0x02:δ֪ʱ
*******************************************************************************/
UINT8 FlashProgByte( UINT16 Addr,UINT8 Data )
{
    bit e_all;
    UINT8 status;                                    /* ز״̬ */
    UINT8 FlashType;                                 /* Flash ͱ־ */
    e_all = EA;
    EA = 0;                                          /* رȫж,ֹFlash */
    if((Addr>0xEFFF) && (Addr<0xF400))               /* DataFlash */
    {
        FlashType = bDATA_WE;
    }
    else                                             /* CodeFlash */
    {
        FlashType = bCODE_WE;
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG |= FlashType;
    ROM_ADDR = Addr;                                 /* дĿַ */
    ROM_BUF_MOD = bROM_BUF_BYTE;                     /* ѡģʽֽڱģʽ */
    ROM_DAT_BUF = Data;                              /* ݻĴ */
    if ( ROM_STATUS & bROM_ADDR_OK )                 /* ַЧ */
    {
        ROM_CTRL = ROM_CMD_PROG ;                    /*  */
        if(ROM_STATUS & bROM_CMD_ERR)
        {
            status = 0x02;    /* δ֪ʱ */
        }
        else
        {
            status = 0x00;    /* ɹ */
        }
    }
    else
    {
        status = 0x01;    /* ַЧ */
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG &= ~FlashType;                        /* д */
    EA = e_all;                                      /* ָȫж״̬ */
    return status;
}
/*******************************************************************************
* Function Name  : FlashVerify
* Description    : FlashУ
* Input          : Addr    оƬ̵ַַַΪżַ
                   pData   ݣWORDΪ׼
                   len     У鳤
* Output         : None
* Return         :         У״̬
                    0x00   Уɹ
                    0xff   Уʧ
*******************************************************************************/
UINT8 FlashVerify( UINT16 Addr, UINT8 *pData, UINT16 len )
{
    UINT16 i;
    pCode = (PUINT8C)( Addr );
    for( i=0; i!=len; i++ )
    {
        if( *pData != *pCode )
        {
            return 0xff;
        }
        pCode++;
        pData++;
    }
    return 0;
}
/*******************************************************************************
* Function Name  : CH549_Respond
* Description    : IAPʱоƬӦ
* Input          : s ЧӦֽ
* Output         : None
* Return         : SBUF ڽֽ
*******************************************************************************/
void CH549_Respond( UINT8 s )
{
    Ep2Buffer[ MAX_PACKET_SIZE ] = s;
    Ep2Buffer[ MAX_PACKET_SIZE+1 ] = 0x00;
    UEP2_T_LEN = 2;
    UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;  // ϴ
}
/*******************************************************************************
* Function Name  : CH549_USB_ISPDownload
* Description    : CH549غ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH549_IAPDownload( void )
{
    UINT8  s;
    UINT16 i;
    UINT16 len;
    UINT32 addr;
    switch( iap_cmd.other.buf[0] )                                  //
    {
    case CMD_IAP_PROM:                                              //ISP 
        len = iap_cmd.program.len;                                  //дֽ
        addr = (iap_cmd.program.addr[0] | (UINT16)iap_cmd.program.addr[1]<<8);
        cur_block = (addr+len-1)/64;                                //´ݵһֽڵַڿ
        if(cur_block!=last_block)
        {
            last_block = cur_block;
            s = FlashErasePage(cur_block<<6);                       //
        }
        if(s == 0)
        {
            for(i=0; i!=len; i++)
            {
                s = FlashProgByte( addr+i,iap_cmd.program.buf[i] ); //ֽڱ,٣Ըĳɿ
                if(s)
                {
                    break;
                }
            }
        }
        CH549_Respond( s );                                         //У
        break;
    case CMD_IAP_ERASE:                                             //ISP ʵʲڱʱ
        cur_block = 0;                                              //CMD_IAP_ERASEǵһҲ,ʴ˴ʼ
        last_block = 0xFFFF;
        CH549_Respond( 0 );
        break;
    case CMD_IAP_VERIFY:                                             // ISP У
        addr = (iap_cmd.verify.addr[0] | (UINT16)iap_cmd.verify.addr[1]<<8);
        len = iap_cmd.verify.len;
        s = FlashVerify( addr,&(iap_cmd.verify.buf[0]),iap_cmd.verify.len );
        CH549_Respond( s );
        break;
    case CMD_IAP_END:                                                // ISP 
        CH549SoftReset();                                            // ִиλ
        break;
    default:
        CH549_Respond( 0xfe );                                       // δ֪
        break;
    }
}
/*******************************************************************************
* Function Name  : USB_DeviceInterrupt
* Description    : USBжϲѯIAP޷ʹж
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USB_DeviceInterrupt( void )
{
    UINT8 len;
    if( UIF_TRANSFER )                                                // USB
    {
        switch ( USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) )// ƺͶ˵
        {
        case UIS_TOKEN_OUT | 2:                                   // endpoint 2# ˵´
            if ( U_TOG_OK )                                       // ͬݰ
            {
                len = USB_RX_LEN;
                memcpy( iap_cmd.other.buf,Ep2Buffer,len );
                uart_bit = 2;
                CH549_IAPDownload( );
            }
            break;
        case UIS_TOKEN_IN | 2:                                    // endpoint 2# ˵ϴ
            UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;// ͣϴ
            break;
        case UIS_TOKEN_SETUP | 0:                                 // endpoint 0# SETUP
            len = USB_RX_LEN;
            if ( len == sizeof( USB_SETUP_REQ ) )                 // SETUP
            {
                SetupLen = UsbSetupBuf->wLengthL;
                if ( UsbSetupBuf->wLengthH || SetupLen > 0x7F )
                {
                    SetupLen = 0x7F;                              // ܳ
                }
                len = 0;                                          // ĬΪɹϴ0
                if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )//ֱֻ֧׼
                {
                    len = 0xFF;                                   // ʧ
                }
                else                                              // ׼
                {
                    SetupReqCode = UsbSetupBuf->bRequest;
                    switch( SetupReqCode )                        // 
                    {
                    case USB_GET_DESCRIPTOR:
                        switch( UsbSetupBuf->wValueH )
                        {
                        case 1:                                   // 豸
                            pDescr = (PUINT8)( &MyDevDescr[0] );
                            len = sizeof( MyDevDescr );
                            break;
                        case 2:                                   // 
                            pDescr = (PUINT8)( &MyCfgDescr[0] );
                            len = sizeof( MyCfgDescr );
                            break;
                        default:
                            len = 0xFF;                           // ֵ֧
                            break;
                        }
                        if ( SetupLen > len )
                        {
                            SetupLen = len;                       // ܳ
                        }
                        len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;// δ䳤
                        memcpy( Ep0Buffer, pDescr, len );         // ϴ
                        SetupLen -= len;
                        pDescr += len;
                        break;
                    case USB_SET_ADDRESS:
                        SetupLen = UsbSetupBuf->wValueL;          // ݴUSB豸ַ
                        break;
                    case USB_GET_CONFIGURATION:
                        Ep0Buffer[0] = UsbConfig;
                        if ( SetupLen >= 1 )
                        {
                            len = 1;
                        }
                        break;
                    case USB_SET_CONFIGURATION:
                        UsbConfig = UsbSetupBuf->wValueL;
                        break;
                    default:
                        len = 0xFF;                               // ʧ
                        break;
                    }
                }
            }
            else
            {
                len = 0xFF;                                       // SETUPȴ
            }
            if ( len == 0xFF )                                    // ʧ
            {
                SetupReqCode = 0xFF;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;// STALL
            }
            else if ( len <= THIS_ENDP0_SIZE )                    // ϴݻ״̬׶η0Ȱ
            {
                UEP0_T_LEN = len;
                UEP0_CTRL  = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;// ĬݰDATA1
            }
            else                                                  // ´ݻ
            {
                UEP0_T_LEN = 0;                                   // Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;// ĬݰDATA1
            }
            break;
        case UIS_TOKEN_IN | 0:                                    // endpoint 0# IN
            switch( SetupReqCode )
            {
            case USB_GET_DESCRIPTOR:
                len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;// δ䳤
                memcpy( Ep0Buffer, pDescr, len );                 // ϴ
                SetupLen -= len;
                pDescr += len;
                UEP0_T_LEN = len;
                UEP0_CTRL ^= bUEP_T_TOG;                          // ת
                break;
            case USB_SET_ADDRESS:
                USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            default:
                UEP0_T_LEN = 0;                                   // ״̬׶жϻǿϴ0ݰƴ
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            }
            break;
        case UIS_TOKEN_OUT | 0:                                   // endpoint 0# OUT
            UEP0_CTRL ^= bUEP_R_TOG;                              //ͬ־λת
            break;
        default:
            break;
        }
        UIF_TRANSFER = 0;                                             // жϱ־
    }
    else if ( UIF_BUS_RST )                                           // USB߸λ
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                              // жϱ־
    }
    else if ( UIF_SUSPEND )                                           // USB߹/
    {
        UIF_SUSPEND = 0;
    }
}
/*******************************************************************************
* Function Name  : InitUSB_Device()
* Description    : USB豸ģʽ,豸ģʽշ˵ãжϿ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitUSB_Device( void )                                         // ʼUSB豸
{
    IE_USB = 0;
    USB_CTRL = 0x00;                                                // 趨ģʽ
    UEP2_3_MOD = bUEP2_RX_EN | bUEP2_TX_EN;                         // ˵2´OUTϴIN
    UEP0_DMA = Ep0Buffer;
    UEP2_DMA = Ep2Buffer;
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
    USB_DEV_AD = 0x00;
    UDEV_CTRL = bUD_PD_DIS;                                         // ֹDP/DM
    USB_CTRL = bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;           // USB豸DMAжڼжϱ־δǰԶNAK
    UDEV_CTRL |= bUD_PORT_EN;                                       // USB˿
    USB_INT_FG = 0xFF;                                              // жϱ־
    USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
}
/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void )
{
    UINT32 j=0;
    CfgFsys();
    mDelaymS(5);
    mInitSTDIO( );
    printf("IAP Demo start...\n");
    EA = 0;                                                              //رжϣIAPʽ޷ʹж
    P1_MOD_OC |= (1<<0);
    P1_DIR_PU |= (1<<0);
    uart_bit = 0;
    InitUSB_Device( );                                                   //USB豸ģʽʼѯʽ
    while(1)
    {
        USB_DeviceInterrupt( );                                          // ѯusbж,鲻ҪƵѯ
        /* ˳iap */
        if( DisableIAP == 0 )                                            // ѯP10͵ƽʱִλִû
        {
            printf("soft reset\n");
            CH549SoftReset();                                            //λ
        }
        j++;
        if(j == 50000)
        {
            D2 = ~D2;                                                      //D2
            j = 0;
        }
    }
}
