/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/21
* Description        : CH549 Time ʼʱֵT2׽ܵ
                       ʱжϴ
                       עDEBUG.C
*******************************************************************************/
#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"
#include ".\Timer\Timer.H"
#pragma  NOAREGS

/* ˿ڶ */
#define  PORT0      0x00
#define  PORT1      0x01
#define  PORT2      0x02
#define  PORT3      0x03
#define  PORT4      0x04
/* Ŷ壨ϣ */
#define  PIN0       0x01
#define  PIN1       0x02
#define  PIN2       0x04
#define  PIN3       0x08
#define  PIN4       0x10
#define  PIN5       0x20
#define  PIN6       0x40
#define  PIN7       0x80
/* ģʽ */
#define  MODE0      0x00                             //ģʽû
#define  MODE1      0x01                             //ģʽжԳսϴ
#define  MODE2      0x02                             //©ָ֧룬û
#define  MODE3      0x03                             //׼˫ģʽ(׼ 8051)©֧룬(Ĭģʽ)

void GPIO_Init(UINT8 PORTx,UINT8 PINx,UINT8 MODEx)
{
    UINT8 Px_DIR_PU,Px_MOD_OC;
    switch(PORTx)                                         //ʼֵ
    {
    case PORT0:
        Px_MOD_OC = P0_MOD_OC;
        Px_DIR_PU = P0_DIR_PU;
        break;
    case PORT1:
        Px_MOD_OC = P1_MOD_OC;
        Px_DIR_PU = P1_DIR_PU;
        break;
    case PORT2:
        Px_MOD_OC = P2_MOD_OC;
        Px_DIR_PU = P2_DIR_PU;
        break;
    case PORT3:
        Px_MOD_OC = P3_MOD_OC;
        Px_DIR_PU = P3_DIR_PU;
        break;
    case PORT4:
        Px_MOD_OC = P4_MOD_OC;
        Px_DIR_PU = P4_DIR_PU;
        break;
    default :
        break;
    }
    switch(MODEx)
    {
    case MODE0:                                       //ģʽû
        Px_MOD_OC &= ~PINx;
        Px_DIR_PU &= ~PINx;
        break;
    case MODE1:                                       //ģʽжԳսϴ
        Px_MOD_OC &= ~PINx;
        Px_DIR_PU |= PINx;
        break;
    case MODE2:                                       //©ָ֧룬û
        Px_MOD_OC |= PINx;
        Px_DIR_PU &= ~PINx;
        break;
    case MODE3:                                       //׼˫ģʽ(׼ 8051)©֧룬
        Px_MOD_OC |= PINx;
        Px_DIR_PU |= PINx;
        break;
    default :
        break;
    }
    switch(PORTx)                                         //д
    {
    case PORT0:
        P0_MOD_OC = Px_MOD_OC;
        P0_DIR_PU = Px_DIR_PU;
        break;
    case PORT1:
        P1_MOD_OC = Px_MOD_OC;
        P1_DIR_PU = Px_DIR_PU;
        break;
    case PORT2:
        P2_MOD_OC = Px_MOD_OC;
        P2_DIR_PU = Px_DIR_PU;
        break;
    case PORT3:
        P3_MOD_OC = Px_MOD_OC;
        P3_DIR_PU = Px_DIR_PU;
        break;
    case PORT4:
        P4_MOD_OC = Px_MOD_OC;
        P4_DIR_PU = Px_DIR_PU;
        break;
    default :
        break;
    }
}

void main( )
{
	float SUMs=0;
    CfgFsys( );                                                                //CH549ʱѡ
    mDelaymS(5);                                                               //޸ƵԼʱȴƵȶ
    mInitSTDIO( );                                                             //ڳʼ
    printf("Timer Demo start ...\n");
    P1_MOD_OC &= ~(1<<7);                                                      //SCK
    P1_DIR_PU |= (1<<7);
	
	GPIO_IE |= bIE_P5_7_HI;
	GPIO_IE |= bIE_IO_EDGE;
	IE_GPIO = 1;
	EA = 1;  
//	PT0 = 1;
	
	GPIO_Init(PORT3,PIN7,MODE0);
	INTX |= bIT3;   //ش
	INTX |= bIX3;   //ش
	flag_int = 0;//
	INTX &= ~bIE3;
	IE_INT3 = 1;
//	IP_EX |= bIP_INT3;
	EA = 1;
	
#ifdef T0_INT
    printf("T0 Test ...\n");
    mTimer0Clk12DivFsys();                                                     //T0ʱʱ FREQ_SYS/12
    mTimer_x_ModInit(0,1);                                                     //T0 ʱģʽ ģʽ1 16λʱ
    mTimer_x_SetData(0,4000);                                                  //T0ʱֵ 24MHZ 1MSж
    mTimer0RunCTL(1);                                                          //T0ʱ
    ET0 = 1;                                                                   //T0ʱжϿ
    EA = 1;
#endif
#ifdef T1_INT                                                                  //ע⣺DEBUG.CmInitSTDIOʹT1ģʽ2Ϊʷ
    printf("T1 Test ...\n");
    mTimer1Clk12DivFsys( );                                                    //T1ʱʱ FREQ_SYS/12
    mTimer_x_ModInit(1,2);                                                     //T1 ʱģʽ,ģʽ2 8λԶװ
    mTimer_x_SetData(1,0xC7C8);                                                //T1ʱֵ TH1=TL1=256-200=38H;  100usж
    mTimer1RunCTL(1);                                                          //T1ʱ
    ET1 = 1;                                                                   //T1ʱжϿ
    EA = 1;
#endif
#ifdef T2_INT
    printf("T2 Test ...\n");
    mTimer2ClkFsys();                                                          //T2ʱʱ  FREQ_SYS
    mTimer_x_ModInit(2,0);                                                     //T2 ʱģʽ
    mTimer_x_SetData(2,48000);                                                 //T2ʱֵ FREQ_SYS=24MHz,2msж
    mTimer2RunCTL(1);                                                          //T2ʱ
    ET2 = 1;                                                                   //T2ʱжϿ
    EA = 1;
#endif
//ͬʱT0SCK
#ifdef T2_CAP
    printf("T2_CAP Test ...\n");
    P1_MOD_OC &= ~(1<<1);                                                     //CAP2 
    P1_DIR_PU &= ~(1<<1);
    P1_MOD_OC &= ~(1<<0);                                                     //CAP1 
    P1_DIR_PU &= ~(1<<0);
    P3_MOD_OC &= ~(1<<6);                                                     //CAP0 
    P3_DIR_PU &= ~(1<<6);
    mTimer2Clk12DivFsys();                                                    //T2ʱʱ FREQ_SYS/12
    mTimer_x_SetData(2,0);                                                    //T2 ʱģʽò׽ģʽ
    CAP2Init(1);                                                              //T2 CAP2(P11)ãز׽
    CAP1Init(1);                                                              //T2 CAP1(P10)ãز׽
    CAP0Init(1);                                                              //T2 CAP0(P36)ãز׽
    mTimer2RunCTL(1);                                                         //T2ʱ
    ET2 = 1;                                                                  //T2ʱжϿ
    EA = 1;
#endif

    while(1)
    {
//			mDelaymS(10);
//			printf("...%d\r",sum_time);
//			printf("UP %d Ms\r",timer_cont);
    }
}

//void GPIO_EXT_ISR(void) interrupt INT_NO_GPIO
//{
//	printf("...");
//   if(flag_int == 0) //
//	{
//		printf("***");
//		flag_int = 1; //ʼʱ־
//		TL0 = 0;
//		TH0 = 0;//0
//		timer_cont = 0;//
//	}
//	else 
//	{
//		flag_int = 0;//ֹͣ
//	}
//	printf("flag_int=%d\r",flag_int);
//}

void GPIO_STD3_ISR(void) interrupt INT_NO_INT3 using 2
{
//	printf("...");
	if(flag_int == 0) //
	{
		TL0 = 0;
		TH0 = 0;//0
		timer_cont = 0;//
		flag_int = 1; //ʼʱ־
		INTX &= ~bIX3; //½شж
	}
	else 
	{
		flag_int = 0;//ֹͣ
		INTX |= bIX3;//ش
	}
//		mDelaymS(10);
//    printf("P37 Falling\n");
}