/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/27
* Description        : CH549 Type-Cʹ
ģʽ(DFP) ּ֧Typc-C豸ĲΣ֧豸ͷ,
              ֧ĬϹ1.5AԼ3AĹ;
ģʽ(UFP) 豸ɼ
                            ĬϹ1.5AԼ3A
DFP (Downstream Facing Port) Host
UFP (Upstream Facing Port)   Dev
עDEBUG.C
*******************************************************************************/
#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"
#include "Type_C.H"
#pragma  NOAREGS
void main( )
{
    UINT16 j = 0;
    CfgFsys( );                                                          //CH549ʱѡ
    mDelaymS(20);                                                        //޸ƵԼʱȴоƬȶ
    mInitSTDIO( );                                                       //0ʼ
    printf("Type-C Demo start ...\n");
#ifdef TYPE_C_DFP                                                        //Type-C壬֪ͨ豸
    TypeC_DFP_Init(3);                                                     //3A
    while(1)
    {
        j = TypeC_DFP_Insert();
        if( j == UCC_DISCONNECT )
        {
            VBUS = 1;                                                          //رVBUS
            printf("UFP disconnect...\n");
        }
        else if( j == UCC1_CONNECT )
        {
            VBUS = 0;                                                          //VBUS
            printf("UFP CC1 insertion...\n");                                  //
        }
        else if( j == UCC2_CONNECT )
        {
            VBUS = 0;                                                          //VBUS
            printf("UFP CC2 insertion...\n");                                  //
        }
        else if( j == UCC_CONNECT )
        {
            VBUS = 0;                                                          //VBUS
            printf("UFP connect...\n");
        }
        mDelaymS(500);                                                       //ʱ壬ģⵥƬִ
    }
#endif
#ifdef TYPE_C_UFP
    TypeC_UPF_PDInit();                                                    //UPFʼ
    while(1)
    {
        j = TypeC_UPF_PDCheck();                                             //Ĺ
        if(j == UPF_PD_Normal)
        {
            printf("DFP defaultPower...\n");
        }
        if(j == UPF_PD_1A5)
        {
            printf("DFP 1.5A...\n");
        }
        if(j == UPF_PD_3A)
        {
            printf("DFP 3.0...\n");
        }
        if(j == UPD_PD_DISCONNECT)
        {
            printf("disconnect...\n");
        }
        mDelaymS( 500 );                                                     //ʱ壬ģⵥƬִ
    }
#endif
}
